<html>
<head>
<title>OgreCompositorInstance.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreCompositorInstance.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreCompositorInstance_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __CompositorInstance_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __CompositorInstance_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterialManager_8h.html">OgreMaterialManager.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreTexture_8h.html">OgreTexture.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderQueue_8h.html">OgreRenderQueue.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreCompositionTechnique_8h.html">OgreCompositionTechnique.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00044"></a><a class="code" href="group__Effects.html#ga56cbccda3a83b1e035e5be74fb17406e">00044</a>     <span class="keyword">const</span> <span class="keywordtype">size_t</span> <a class="code" href="group__Effects.html#ga56cbccda3a83b1e035e5be74fb17406e">RENDER_QUEUE_COUNT</a> = <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&#39;t exceed this.">RENDER_QUEUE_MAX</a>+1;       
<a name="l00045"></a>00045             
<a name="l00049"></a><a class="code" href="classOgre_1_1CompositorInstance.html">00049</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">CompositorInstAlloc</a>
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00052"></a>00052         <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>(<a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> *technique, <a class="code" href="classOgre_1_1CompositorChain.html" title="Chain of compositor effects applying to one viewport.">CompositorChain</a> *chain);
<a name="l00053"></a>00053         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>();
<a name="l00057"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1Listener.html">00057</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1CompositorInstance_1_1Listener.html" title="Provides an interface to &quot;listen in&quot; to to render system operations executed by this CompositorInstan...">Listener</a>
<a name="l00058"></a>00058         {
<a name="l00059"></a>00059         <span class="keyword">public</span>:
<a name="l00060"></a>00060             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1CompositorInstance_1_1Listener.html" title="Provides an interface to &quot;listen in&quot; to to render system operations executed by this CompositorInstan...">Listener</a>();
<a name="l00061"></a>00061 
<a name="l00071"></a>00071             <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyMaterialSetup(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> pass_id, <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> &amp;mat);
<a name="l00072"></a>00072 
<a name="l00081"></a>00081             <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyMaterialRender(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> pass_id, <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> &amp;mat);
<a name="l00082"></a>00082 
<a name="l00086"></a>00086             <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyResourcesCreated(<span class="keywordtype">bool</span> forResizeOnly);
<a name="l00087"></a>00087             
<a name="l00088"></a>00088         };
<a name="l00093"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1RenderSystemOperation.html">00093</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1CompositorInstance_1_1RenderSystemOperation.html" title="Specific render system operation.">RenderSystemOperation</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">CompositorInstAlloc</a>
<a name="l00094"></a>00094         {
<a name="l00095"></a>00095         <span class="keyword">public</span>:
<a name="l00096"></a>00096             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1CompositorInstance_1_1RenderSystemOperation.html" title="Specific render system operation.">RenderSystemOperation</a>();
<a name="l00098"></a>00098             <span class="keyword">virtual</span> <span class="keywordtype">void</span> execute(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> *sm, <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a> *rs) = 0;
<a name="l00099"></a>00099         };
<a name="l00100"></a><a class="code" href="classOgre_1_1CompositorInstance.html#aba84d505b7d7089a2c6bb9f3a8379c86">00100</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt;int, MaterialPtr&gt;::type</a> <a class="code" href="classOgre_1_1CompositorInstance.html#aba84d505b7d7089a2c6bb9f3a8379c86">QuadMaterialMap</a>;
<a name="l00101"></a><a class="code" href="classOgre_1_1CompositorInstance.html#ab03be79964e60192fc2d4446b81b29fe">00101</a>         <span class="keyword">typedef</span> std::pair&lt;int, RenderSystemOperation*&gt; <a class="code" href="classOgre_1_1CompositorInstance.html#ab03be79964e60192fc2d4446b81b29fe">RenderSystemOpPair</a>;
<a name="l00102"></a><a class="code" href="classOgre_1_1CompositorInstance.html#ad76c35638d871dd4db8636ab91d1df94">00102</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;RenderSystemOpPair&gt;::type</a> <a class="code" href="classOgre_1_1CompositorInstance.html#ad76c35638d871dd4db8636ab91d1df94">RenderSystemOpPairs</a>;
<a name="l00105"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html">00105</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html" title="Operation setup for a RenderTarget (collected).">TargetOperation</a>
<a name="l00106"></a>00106         {
<a name="l00107"></a>00107         <span class="keyword">public</span>:
<a name="l00108"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#ae830521a3572e0c30c145e9e74c779de">00108</a>             <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html" title="Operation setup for a RenderTarget (collected).">TargetOperation</a>()
<a name="l00109"></a>00109             { 
<a name="l00110"></a>00110             }
<a name="l00111"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a4a07f4c5f9abe2a6f760f612434db34f">00111</a>             <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html" title="Operation setup for a RenderTarget (collected).">TargetOperation</a>(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *inTarget):
<a name="l00112"></a>00112                 target(inTarget), currentQueueGroupID(0), visibilityMask(0xFFFFFFFF),
<a name="l00113"></a>00113                 lodBias(1.0f),
<a name="l00114"></a>00114                 onlyInitial(false), hasBeenRendered(false), findVisibleObjects(false), 
<a name="l00115"></a>00115                 materialScheme(<a class="code" href="classOgre_1_1MaterialManager.html" title="Class for managing Material settings for Ogre.">MaterialManager</a>::DEFAULT_SCHEME_NAME), shadowsEnabled(true)
<a name="l00116"></a>00116             { 
<a name="l00117"></a>00117             }
<a name="l00119"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#af5c5f5aab22a31e194c2bba815d01b49">00119</a>             <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *<a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#af5c5f5aab22a31e194c2bba815d01b49" title="Target.">target</a>;
<a name="l00120"></a>00120 
<a name="l00122"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#af87bc9636c803efa26fbcc4f5a4fa063">00122</a>             <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#af87bc9636c803efa26fbcc4f5a4fa063" title="Current group ID.">currentQueueGroupID</a>;
<a name="l00123"></a>00123 
<a name="l00126"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a91205dfe635e89525f6080c93a913522">00126</a>             <a class="code" href="classOgre_1_1CompositorInstance.html#ad76c35638d871dd4db8636ab91d1df94">RenderSystemOpPairs</a> <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a91205dfe635e89525f6080c93a913522" title="RenderSystem operations to queue into the scene manager, by uint8.">renderSystemOperations</a>;
<a name="l00127"></a>00127 
<a name="l00130"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#aa068061eb691af0d3b0ff440004221a8">00130</a>             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#aa068061eb691af0d3b0ff440004221a8" title="Scene visibility mask If this is 0, the scene is not rendered at all.">visibilityMask</a>;
<a name="l00131"></a>00131             
<a name="l00134"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a8ba9a8940b2e81cb3e866cce28697a4f">00134</a>             <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a8ba9a8940b2e81cb3e866cce28697a4f" title="LOD offset.">lodBias</a>;
<a name="l00135"></a>00135             
<a name="l00138"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a7026db7788bde13a6b6466a967733b64">00138</a>             <span class="keyword">typedef</span> std::bitset&lt;RENDER_QUEUE_COUNT&gt; <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a7026db7788bde13a6b6466a967733b64" title="A set of render queues to either include or exclude certain render queues.">RenderQueueBitSet</a>;
<a name="l00139"></a>00139 
<a name="l00141"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a4d359b9d7ce499be7c9e72e62a0a5787">00141</a>             <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a7026db7788bde13a6b6466a967733b64" title="A set of render queues to either include or exclude certain render queues.">RenderQueueBitSet</a> <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a4d359b9d7ce499be7c9e72e62a0a5787" title="Which renderqueues to render from scene.">renderQueues</a>;
<a name="l00142"></a>00142             
<a name="l00145"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a56bb029bcccd70874ba6474e66393fdd">00145</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a56bb029bcccd70874ba6474e66393fdd">onlyInitial</a>;
<a name="l00149"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a29e5d3e3b946b36d3b253d78e3a66b89">00149</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a29e5d3e3b946b36d3b253d78e3a66b89" title="&quot;Has been rendered&quot; flag; used in combination with onlyInitial to determine whether to skip this targ...">hasBeenRendered</a>;
<a name="l00152"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a09330d104546144ccb1ff53510fb826a">00152</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#a09330d104546144ccb1ff53510fb826a" title="Whether this op needs to find visible scene objects or not.">findVisibleObjects</a>;
<a name="l00154"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#ac5258ce0ba7b24c2854ec37543daa59f">00154</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#ac5258ce0ba7b24c2854ec37543daa59f" title="Which material scheme this op will use.">materialScheme</a>;
<a name="l00156"></a><a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#ac130ef8cace8c4af74ba60f37deb25fe">00156</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#ac130ef8cace8c4af74ba60f37deb25fe" title="Whether shadows will be enabled.">shadowsEnabled</a>;
<a name="l00157"></a>00157         };
<a name="l00158"></a><a class="code" href="classOgre_1_1CompositorInstance.html#afc24e918e5a1f648385d3ca6df3fc281">00158</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;TargetOperation&gt;::type</a> <a class="code" href="classOgre_1_1CompositorInstance.html#afc24e918e5a1f648385d3ca6df3fc281">CompiledState</a>;
<a name="l00159"></a>00159         
<a name="l00164"></a>00164         <span class="keywordtype">void</span> setEnabled(<span class="keywordtype">bool</span> value);
<a name="l00165"></a>00165         
<a name="l00168"></a><a class="code" href="classOgre_1_1CompositorInstance.html#a0b1d456f8ff81bfb13e39220380de33b">00168</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorInstance.html#a0b1d456f8ff81bfb13e39220380de33b" title="Get enabled flag.">getEnabled</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mEnabled; }
<a name="l00169"></a>00169 
<a name="l00175"></a>00175         <span class="keywordtype">void</span> setAlive(<span class="keywordtype">bool</span> value);
<a name="l00176"></a>00176 
<a name="l00179"></a><a class="code" href="classOgre_1_1CompositorInstance.html#a11970997dd7affd4c69bc4916b5a790c">00179</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorInstance.html#a11970997dd7affd4c69bc4916b5a790c" title="Get alive flag.">getAlive</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAlive; }
<a name="l00180"></a>00180 
<a name="l00191"></a>00191         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTextureInstanceName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">size_t</span> mrtIndex);
<a name="l00192"></a>00192 
<a name="l00203"></a>00203         <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> getTextureInstance(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">size_t</span> mrtIndex);
<a name="l00204"></a>00204 
<a name="l00211"></a>00211         <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a>* getRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213        
<a name="l00217"></a>00217         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _compileTargetOperations(CompiledState &amp;compiledState);
<a name="l00218"></a>00218         
<a name="l00222"></a>00222         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _compileOutputOperation(TargetOperation &amp;finalState);
<a name="l00223"></a>00223         
<a name="l00226"></a>00226         <a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a> *getCompositor();
<a name="l00227"></a>00227         
<a name="l00230"></a>00230         <a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> *getTechnique();
<a name="l00231"></a>00231 
<a name="l00237"></a>00237         <span class="keywordtype">void</span> setTechnique(<a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a>* tech, <span class="keywordtype">bool</span> reuseTextures = <span class="keyword">true</span>);
<a name="l00238"></a>00238 
<a name="l00250"></a>00250         <span class="keywordtype">void</span> setScheme(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; schemeName, <span class="keywordtype">bool</span> reuseTextures = <span class="keyword">true</span>);
<a name="l00251"></a>00251 
<a name="l00253"></a><a class="code" href="classOgre_1_1CompositorInstance.html#a4213346639ba7f4d6b517a8dfbfc1c7d">00253</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1CompositorInstance.html#a4213346639ba7f4d6b517a8dfbfc1c7d" title="Returns the name of the scheme this compositor is using.">getScheme</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTechnique ? mTechnique-&gt;getSchemeName() : <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>; }
<a name="l00254"></a>00254 
<a name="l00260"></a>00260         <span class="keywordtype">void</span> notifyResized();
<a name="l00261"></a>00261 
<a name="l00264"></a>00264         <a class="code" href="classOgre_1_1CompositorChain.html" title="Chain of compositor effects applying to one viewport.">CompositorChain</a> *getChain();
<a name="l00265"></a>00265 
<a name="l00271"></a>00271         <span class="keywordtype">void</span> addListener(Listener *l);
<a name="l00272"></a>00272 
<a name="l00276"></a>00276         <span class="keywordtype">void</span> removeListener(Listener *l);
<a name="l00277"></a>00277 
<a name="l00280"></a>00280         <span class="keywordtype">void</span> _fireNotifyMaterialSetup(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> pass_id, <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> &amp;mat);
<a name="l00281"></a>00281 
<a name="l00284"></a>00284         <span class="keywordtype">void</span> _fireNotifyMaterialRender(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> pass_id, <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> &amp;mat);
<a name="l00285"></a>00285 
<a name="l00288"></a>00288         <span class="keywordtype">void</span> _fireNotifyResourcesCreated(<span class="keywordtype">bool</span> forResizeOnly);
<a name="l00289"></a>00289     <span class="keyword">private</span>:
<a name="l00291"></a><a class="code" href="classOgre_1_1CompositorInstance.html#ad527be1fedec4112efe9eb3ff8f6b925">00291</a>         <a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a> *<a class="code" href="classOgre_1_1CompositorInstance.html#ad527be1fedec4112efe9eb3ff8f6b925" title="Compositor of which this is an instance.">mCompositor</a>;
<a name="l00293"></a><a class="code" href="classOgre_1_1CompositorInstance.html#a3d3a380fb753ad28cc3119d0f15868a4">00293</a>         <a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> *<a class="code" href="classOgre_1_1CompositorInstance.html#a3d3a380fb753ad28cc3119d0f15868a4" title="Composition technique used by this instance.">mTechnique</a>;
<a name="l00295"></a><a class="code" href="classOgre_1_1CompositorInstance.html#abeb0b38cce2a6c765390544d054a75cf">00295</a>         <a class="code" href="classOgre_1_1CompositorChain.html" title="Chain of compositor effects applying to one viewport.">CompositorChain</a> *<a class="code" href="classOgre_1_1CompositorInstance.html#abeb0b38cce2a6c765390544d054a75cf" title="Composition chain of which this instance is part.">mChain</a>;
<a name="l00297"></a><a class="code" href="classOgre_1_1CompositorInstance.html#ae14d9e70c48e35de5a49ebf29777a8f7">00297</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorInstance.html#ae14d9e70c48e35de5a49ebf29777a8f7" title="Is this instance enabled?">mEnabled</a>;
<a name="l00299"></a><a class="code" href="classOgre_1_1CompositorInstance.html#a5b11e9b63fbf6ad059b7d4746d2f72bf">00299</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorInstance.html#a5b11e9b63fbf6ad059b7d4746d2f72bf" title="Is this instance allocating resources?">mAlive</a>;
<a name="l00301"></a><a class="code" href="classOgre_1_1CompositorInstance.html#a2b3da3971a4d36561ecd0eac17e08703">00301</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String,TexturePtr&gt;::type</a> <a class="code" href="classOgre_1_1CompositorInstance.html#a2b3da3971a4d36561ecd0eac17e08703" title="Map from name-&gt;local texture.">LocalTextureMap</a>;
<a name="l00302"></a><a class="code" href="classOgre_1_1CompositorInstance.html#afb44967dff9b29465e5e5ea7aa9d67ff">00302</a>         <a class="code" href="classOgre_1_1CompositorInstance.html#a2b3da3971a4d36561ecd0eac17e08703" title="Map from name-&gt;local texture.">LocalTextureMap</a> <a class="code" href="classOgre_1_1CompositorInstance.html#afb44967dff9b29465e5e5ea7aa9d67ff">mLocalTextures</a>;
<a name="l00304"></a><a class="code" href="classOgre_1_1CompositorInstance.html#a7801c212731600b969e4f39c2628adf9">00304</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String,MultiRenderTarget*&gt;::type</a> <a class="code" href="classOgre_1_1CompositorInstance.html#a7801c212731600b969e4f39c2628adf9" title="Store a list of MRTs we&#39;ve created.">LocalMRTMap</a>;
<a name="l00305"></a><a class="code" href="classOgre_1_1CompositorInstance.html#a016792e48c0099618a03df086f857091">00305</a>         <a class="code" href="classOgre_1_1CompositorInstance.html#a7801c212731600b969e4f39c2628adf9" title="Store a list of MRTs we&#39;ve created.">LocalMRTMap</a> <a class="code" href="classOgre_1_1CompositorInstance.html#a016792e48c0099618a03df086f857091">mLocalMRTs</a>;
<a name="l00306"></a><a class="code" href="classOgre_1_1CompositorInstance.html#ad3d3ea9eff9a51d74f349c73b223c81c">00306</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;CompositionTechnique::TextureDefinition*, TexturePtr&gt;::type</a> <a class="code" href="classOgre_1_1CompositorInstance.html#ad3d3ea9eff9a51d74f349c73b223c81c">ReserveTextureMap</a>;
<a name="l00311"></a><a class="code" href="classOgre_1_1CompositorInstance.html#a99dfc9539238b0b2356237fa8371b505">00311</a>         <a class="code" href="classOgre_1_1CompositorInstance.html#ad3d3ea9eff9a51d74f349c73b223c81c">ReserveTextureMap</a> <a class="code" href="classOgre_1_1CompositorInstance.html#a99dfc9539238b0b2356237fa8371b505" title="Textures that are not currently in use, but that we want to keep for now, for example if we switch te...">mReserveTextures</a>;
<a name="l00312"></a>00312 
<a name="l00314"></a><a class="code" href="classOgre_1_1CompositorInstance.html#aa62e746c4a3904e9a6df37de65e48395">00314</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Listener*&gt;::type</a> <a class="code" href="classOgre_1_1CompositorInstance.html#aa62e746c4a3904e9a6df37de65e48395" title="Vector of listeners.">Listeners</a>;
<a name="l00315"></a><a class="code" href="classOgre_1_1CompositorInstance.html#a4476eeba8785b7684dcc83e3a8bb7d31">00315</a>         <a class="code" href="classOgre_1_1CompositorInstance.html#aa62e746c4a3904e9a6df37de65e48395" title="Vector of listeners.">Listeners</a> <a class="code" href="classOgre_1_1CompositorInstance.html#a4476eeba8785b7684dcc83e3a8bb7d31">mListeners</a>;
<a name="l00316"></a>00316         
<a name="l00318"></a><a class="code" href="classOgre_1_1CompositorInstance.html#acdac0c97861080d95c032ef8c21721e3">00318</a>         <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a> *<a class="code" href="classOgre_1_1CompositorInstance.html#acdac0c97861080d95c032ef8c21721e3" title="Previous instance (set by chain)">mPreviousInstance</a>;
<a name="l00319"></a>00319         
<a name="l00323"></a>00323         <span class="keyword">virtual</span> <span class="keywordtype">void</span> collectPasses(<a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html" title="Operation setup for a RenderTarget (collected).">TargetOperation</a> &amp;finalState, <a class="code" href="classOgre_1_1CompositionTargetPass.html" title="Object representing one render to a RenderTarget or Viewport in the Ogre Composition framework...">CompositionTargetPass</a> *target);
<a name="l00324"></a>00324         
<a name="l00329"></a>00329         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> createLocalMaterial(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; srcName);
<a name="l00330"></a>00330         
<a name="l00333"></a>00333         <span class="keywordtype">void</span> createResources(<span class="keywordtype">bool</span> forResizeOnly);
<a name="l00334"></a>00334         
<a name="l00337"></a>00337         <span class="keywordtype">void</span> freeResources(<span class="keywordtype">bool</span> forResizeOnly, <span class="keywordtype">bool</span> clearReserveTextures);
<a name="l00338"></a>00338 
<a name="l00341"></a>00341         <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *getTargetForTex(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name);
<a name="l00342"></a>00342         
<a name="l00347"></a>00347         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;getSourceForTex(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keywordtype">size_t</span> mrtIndex = 0);
<a name="l00348"></a>00348 
<a name="l00352"></a>00352         <span class="keywordtype">void</span> queueRenderSystemOp(<a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html" title="Operation setup for a RenderTarget (collected).">TargetOperation</a> &amp;finalState, <a class="code" href="classOgre_1_1CompositorInstance_1_1RenderSystemOperation.html" title="Specific render system operation.">RenderSystemOperation</a> *op);
<a name="l00353"></a>00353 
<a name="l00355"></a>00355         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getMRTTexLocalName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; baseName, <span class="keywordtype">size_t</span> attachment);
<a name="l00356"></a>00356 
<a name="l00360"></a>00360         <span class="keywordtype">void</span> deriveTextureRenderTargetOptions(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; texname, 
<a name="l00361"></a>00361             <span class="keywordtype">bool</span> *hwGammaWrite, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> *fsaa, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>* fsaaHint);
<a name="l00362"></a>00362 
<a name="l00364"></a>00364         <span class="keywordtype">void</span> notifyCameraChanged(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* camera);
<a name="l00365"></a>00365 
<a name="l00366"></a><a class="code" href="classOgre_1_1CompositorInstance.html#a37ae5ce58afd2f0684c967bb1e780f58">00366</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1CompositorChain.html" title="Chain of compositor effects applying to one viewport.">CompositorChain</a>;
<a name="l00367"></a>00367     };
<a name="l00371"></a>00371 }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
